"""
Django settings for settings project.

Generated by 'django-admin startproject' using Django 3.2.3.

For more informatioan on this file, see
https://docs.djangoproject.com/en/3.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.2/ref/settings/
"""

import os
from pathlib import Path

DEBUG = False

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent.parent
ALLOWED_HOSTS = ["*"]

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.getenv("DJANGO_SECRET_KEY", "")

# Application definition

DEFAULT_APPS = [
    # 'django.contrib.admin',
    # 'django.contrib.auth',
    "django.contrib.contenttypes",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
]

OTHER_APPS = ["storages"]

LOCAL_APPS = [
    "stocks_analysis",
]

INSTALLED_APPS = DEFAULT_APPS + OTHER_APPS + LOCAL_APPS

MIDDLEWARE = [
    "django.middleware.security.SecurityMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    # 'django.contrib.auth.middleware.AuthenticationMiddleware',
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
]

ROOT_URLCONF = "settings.urls"

TEMPLATE_DIR = BASE_DIR / "templates"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [TEMPLATE_DIR],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                # 'django.contrib.auth.context_processors.auth',
                "django.contrib.messages.context_processors.messages",
            ],
        },
    },
]

WSGI_APPLICATION = "settings.wsgi.application"

# Internationalization
# https://docs.djangoproject.com/en/3.2/topics/i18n/

LANGUAGE_CODE = "en-us"

TIME_ZONE = "Europe/Paris"

USE_I18N = True

USE_L10N = True

USE_TZ = True

# Storage
USE_S3 = os.getenv("USE_S3", "False").upper() == "TRUE"

AWS_ACCESS_KEY_ID = os.getenv("AWS_ACCESS_KEY_ID_DJANGO")
AWS_SECRET_ACCESS_KEY = os.getenv("AWS_SECRET_ACCESS_KEY_DJANGO")

AWS_S3_REGION_NAME = "eu-west-1"
AWS_S3_ENDPOINT_URL = "https://s3.k8s.infra.cedricfarinazzo.fr"

if USE_S3:
    # AWS settings
    AWS_STORAGE_BUCKET_NAME = os.getenv("AWS_STORAGE_BUCKET_NAME_DJANGO")

    AWS_DEFAULT_ACL = None
    AWS_IS_GZIPPED = True
    AWS_S3_OBJECT_PARAMETERS = {
        "CacheControl": "max-age=86400",
    }

    # Static
    STATIC_URL = f"{AWS_S3_ENDPOINT_URL}/{AWS_STORAGE_BUCKET_NAME}/static"
    STATICFILES_STORAGE = "settings.storage_backend.StaticStorage"

    # Media
    MEDIA_URL = f"{AWS_S3_ENDPOINT_URL}/{AWS_STORAGE_BUCKET_NAME}/media"
    DEFAULT_FILE_STORAGE = "settings.storage_backend.MediaStorage"

    STATICFILES_DIRS = (os.path.join(BASE_DIR, "static"),)
else:
    STATIC_URL = "/static/"
    STATIC_ROOT = os.path.join(BASE_DIR, "static")
    MEDIA_URL = "/media/"
    MEDIA_ROOT = os.path.join(BASE_DIR, "media")


# App

QUANDL_API_KEY = os.getenv("QUANDL_API_KEY", "")
QUANDL_START_DATE = "2015-01-01"
QUANDL_FETCH_COLUMNS = ["Date", "Open", "High", "Low", "Last"]

TEMPLATE_FILE = "template.xlsx"
TEMPLATE_SHEET_NAME_CELL = "A3"
TEMPLATE_COLUMNS_DICT = {
    "Date": 2,
    "Open": 5,
    "High": 3,
    "Low": 4,
    "Last": 6,
}
TEMPLATE_DATA_ROW_OFFSET = 6
TEMPLATE_STYLE_COL_ID = 8
TEMPLATE_FORMULA_EXPAND_OFFSET = 300

DATAFILE_NAME = "report.xlsx"
DATAFILE_URL = MEDIA_URL + "/" + DATAFILE_NAME

CONFIG_PATH = "config.json"
DEFAULT_CONFIG = {"list": []}

STATUSFILE_PATH = "status.json"
